 ###############################################################################
 #  Copyright 2006 Ian McIntosh <ian@openanswers.org>
 #
 #  This program is free software; you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
 #  the Free Software Foundation; either version 2 of the License, or
 #  (at your option) any later version.
 #
 #  This program is distributed in the hope that it will be useful,
 #  but WITHOUT ANY WARRANTY; without even the implied warranty of
 #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #  GNU Library General Public License for more details.
 #
 #  You should have received a copy of the GNU General Public License
 #  along with this program; if not, write to the Free Software
 #  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 ###############################################################################

require 'parent_user_object_liststore'

class DirectorListStore < ParentUserObjectListStore
	TITLE_AND_TAGS_FORMAT = "%s\n<small><small>  %s</small></small>"			# NOTE: tags has an extra space so row doesn't change size when tags are added
	column :title_and_tags, :type => :text, :from_object => Proc.new { |object| sprintf(TITLE_AND_TAGS_FORMAT, object.title.with_optional_pango_tag(object.crashy?, 'i'), (object.tags.empty?) ? '' : "tags #{object.tags.collect { |t| t.with_pango_tag('u') }.join(', ')}") }
end
