 ###############################################################################
 #  Copyright 2006 Ian McIntosh <ian@openanswers.org>
 #
 #  This program is free software; you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
 #  the Free Software Foundation; either version 2 of the License, or
 #  (at your option) any later version.
 #
 #  This program is distributed in the hope that it will be useful,
 #  but WITHOUT ANY WARRANTY; without even the implied warranty of
 #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #  GNU Library General Public License for more details.
 #
 #  You should have received a copy of the GNU General Public License
 #  along with this program; if not, write to the Free Software
 #  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 ###############################################################################

require 'user_object'

class EventInput < UserObject
	attr_reader :last_value, :last_activation_time		# for use by plugins

	def after_load
		set_default_instance_variables(:last_value => false, :last_activation_time => 0.0)
		super
	end

	def previous_frame?
		@last_value
	end

	def time_since_last_activation
		$env[:time] - @last_activation_time
	end

	def do_value
		return false unless enabled?
		return @last_value if $env[:frame_number] == @last_resolve_frame_number

		@last_resolve_frame_number = $env[:frame_number]	# Do this first to avoid any possible recurrsion issues.

		resolve_settings

		user_object_try {
			@last_value = self.value
			@last_activation_time = $env[:time] if @last_value
			return @last_value
		}
		return false	# In case of exceptions
	end
end
