 ###############################################################################
 #  Copyright 2008 Ian McIntosh <ian@openanswers.org>
 #
 #  This program is free software; you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
 #  the Free Software Foundation; either version 2 of the License, or
 #  (at your option) any later version.
 #
 #  This program is distributed in the hope that it will be useful,
 #  but WITHOUT ANY WARRANTY; without even the implied warranty of
 #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #  GNU Library General Public License for more details.
 #
 #  You should have received a copy of the GNU General Public License
 #  along with this program; if not, write to the Free Software
 #  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 ###############################################################################

require 'osc_server'
require 'callbacks'

class MessageBus < OSCServer
	include Callbacks

	callback :button_down
	callback :button_up
	callback :slider_change

private

	def on_new_message(message)
		if message.args.length == 1
			if message.args[0].is_a? OSC::OSCFloat32
				f = message.args[0].to_f
				slider_change_notify(message.address, (f > 1.0) ? 1.0 : ((f < 0.0) ? 0.0 : f))
			elsif message.args[0].is_a? OSC::OSCInt32
				if message.args[0].to_i >= 1		# NOTE: this is just to be flexible (but all of the apps written for Luz send 1=down, 0=up)
					button_down_notify(message.address)
				else
					button_up_notify(message.address)
				end
			else
				@ignored_message_count += 1
			end
		else
			# NOTE: so far no need for messages with 0 or >1 arguments
			@ignored_message_count += 1
		end
	end
end
