 ###############################################################################
 #  Copyright 2006 Ian McIntosh <ian@openanswers.org>
 #
 #  This program is free software; you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
 #  the Free Software Foundation; either version 2 of the License, or
 #  (at your option) any later version.
 #
 #  This program is distributed in the hope that it will be useful,
 #  but WITHOUT ANY WARRANTY; without even the implied warranty of
 #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #  GNU Library General Public License for more details.
 #
 #  You should have received a copy of the GNU General Public License
 #  along with this program; if not, write to the Free Software
 #  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 ###############################################################################

class ActorEffectCanvasPaintSplatter < ActorEffectCanvas
	title				"Canvas Paint Splatter"
	description "Randomly splatters bits of paint"

	setting 'splatter', :event
	setting 'x', :float, :range => -0.5..0.5, :default => -0.5..0.5
	setting 'y', :float, :range => -0.5..0.5, :default => -0.5..0.5
	setting 'radius', :float, :range => 0.0..2.0, :default => 0.05..2.0

	def paint(c)
		lifetime = 2

		@splatters ||= []
		if splatter.now?
			@splatters << [x,y,radius,$env[:time]]
#			@splatters << [x + rand_in_range(-radius,radius),y + rand_in_range(-radius,radius), radius / 2.0, $env[:time]]
#			@splatters << [x + rand_in_range(-radius,radius),y + rand_in_range(-radius,radius), radius / 3.0, $env[:time]]
		end

		unless @splatters.empty?
			@splatters.shift if @splatters.size > 20

			number_to_remove = 0
			@splatters.each_with_index { |splatter, index|
				c.save
					c.set_source_rgba(1,1,1,0.1)

					progress = (($env[:time] - splatter[3]) / lifetime).clamp(0.0, 1.0)
					radius = progress.scale(0, splatter[2])

					c.move_to(splatter[0], splatter[1])
					c.arc(splatter[0], splatter[1], radius, 0, 2*Math::PI)

					number_to_remove = index+1 if progress >= 1.0
					c.fill
				c.restore
			}

			# Remove dead ones
			number_to_remove.times do @splatters.shift end
		end
	end
end
