 ###############################################################################
 #  Copyright 2006 Ian McIntosh <ian@openanswers.org>
 #
 #  This program is free software; you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
 #  the Free Software Foundation; either version 2 of the License, or
 #  (at your option) any later version.
 #
 #  This program is distributed in the hope that it will be useful,
 #  but WITHOUT ANY WARRANTY; without even the implied warranty of
 #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #  GNU Library General Public License for more details.
 #
 #  You should have received a copy of the GNU General Public License
 #  along with this program; if not, write to the Free Software
 #  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 ###############################################################################

class ActorEffectHideCircular < ActorEffect
	title				"Hide Circular"
	description "Hides actor in a circular sweep"

	setting 'start_angle', :float, :range => -2.0..2.0, :default => 0.0..1.0
	setting 'amount', :float, :range => -1.0..1.0, :default => 0.0..1.0

	def render
		# Make a local variable out of it
		start_angle_local = self.start_angle

		# Without this, when amount<0.0 the wedge jumps to opposite side of the origin
		start_angle_local += 0.5 if amount < 0.0

		# Draw "left" half
		with_clip_plane_right_of_angle(start_angle_local) {
			with_clip_plane_right_of_angle(start_angle_local + amount / 2) {
				yield
			}
		}

		# Draw "right" half
		with_clip_plane_left_of_angle(start_angle_local + amount) {
			with_clip_plane_left_of_angle(start_angle_local + amount / 2) {
				yield
			}
		}
	end
end
