 ###############################################################################
 #  Copyright 2006 Ian McIntosh <ian@openanswers.org>
 #
 #  This program is free software; you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
 #  the Free Software Foundation; either version 2 of the License, or
 #  (at your option) any later version.
 #
 #  This program is distributed in the hope that it will be useful,
 #  but WITHOUT ANY WARRANTY; without even the implied warranty of
 #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #  GNU Library General Public License for more details.
 #
 #  You should have received a copy of the GNU General Public License
 #  along with this program; if not, write to the Free Software
 #  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 ###############################################################################

class ActorEffectSpin < ActorEffect
	virtual # deprecated

	title				'Spin'
	description ''

	setting 'rotation_time', :timespan
	setting 'speed', :float, :range => -1.0..1.0, :default => 0.0..1.0

	def tick
		@rotations ||= 0.0
		@rotations += (($env[:frame_time_delta] / rotation_time.to_seconds) * speed) unless rotation_time.instant?
	end

	def render
		tick
		rotate(@rotations) {
			yield
		}
	end
end
