 ###############################################################################
 #  Copyright 2006 Ian McIntosh <ian@openanswers.org>
 #
 #  This program is free software; you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
 #  the Free Software Foundation; either version 2 of the License, or
 #  (at your option) any later version.
 #
 #  This program is distributed in the hope that it will be useful,
 #  but WITHOUT ANY WARRANTY; without even the implied warranty of
 #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #  GNU Library General Public License for more details.
 #
 #  You should have received a copy of the GNU General Public License
 #  along with this program; if not, write to the Free Software
 #  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 ###############################################################################

class ActorEffectThemeChildrenSelectRotate < ActorEffect
	title				"Theme Children Select Rotate"
	description "Animates selected theme to style each successive child differently."

	setting 'themes', :themes
	setting 'next_theme', :event
	setting 'previous_theme', :event
	setting 'rotate_forwards', :event
	setting 'rotate_backwards', :event

	def render
		return yield if themes.count == 0

		themes.one(next_theme.count - previous_theme.count) { |theme|
			theme.using_style(child_index + rotate_forwards_setting.count - rotate_backwards_setting.count) {
				yield
			}
		}
	end
end
