 ###############################################################################
 #  Copyright 2006 Ian McIntosh <ian@openanswers.org>
 #
 #  This program is free software; you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
 #  the Free Software Foundation; either version 2 of the License, or
 #  (at your option) any later version.
 #
 #  This program is distributed in the hope that it will be useful,
 #  but WITHOUT ANY WARRANTY; without even the implied warranty of
 #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #  GNU Library General Public License for more details.
 #
 #  You should have received a copy of the GNU General Public License
 #  along with this program; if not, write to the Free Software
 #  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 ###############################################################################

class ActorEffectVariableRouter4Port < ActorEffect
	title				"Variable Router 4-Port"
	description "Activates chosen output variable differently for each child."

	setting 'input_variable_1', :variable
	setting 'input_variable_2', :variable
	setting 'input_variable_3', :variable
	setting 'input_variable_4', :variable

	setting 'output_variable', :variable

	def render
		variable = output_variable_setting.variable
		return yield unless variable

		value = case (child_index % 4)
			when 0
				input_variable_1
			when 1
				input_variable_2
			when 2
				input_variable_3
			when 3
				input_variable_4
			end

		variable.with_value(value) {
			yield
		}
	end
end
