 ###############################################################################
 #  Copyright 2006 Ian McIntosh <ian@openanswers.org>
 #
 #  This program is free software; you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
 #  the Free Software Foundation; either version 2 of the License, or
 #  (at your option) any later version.
 #
 #  This program is distributed in the hope that it will be useful,
 #  but WITHOUT ANY WARRANTY; without even the implied warranty of
 #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #  GNU Library General Public License for more details.
 #
 #  You should have received a copy of the GNU General Public License
 #  along with this program; if not, write to the Free Software
 #  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 ###############################################################################

class DirectorEffectActorXYZRollPitchYawZoom2D < DirectorEffect
	virtual	# deprecated

	title				'Actor XYZ Roll Pitch Yaw Zoom2D'
	description 'Puts a single actor on stage at a controllable x, y, z, roll, pitch, and yaw, with a zoom 2d'

	setting 'actor', :actor

	setting 'x_offset', :float, :default => 0.0..1.0
	setting 'y_offset', :float, :default => 0.0..1.0
	setting 'z_offset', :float, :default => 0.0..1.0

	setting 'roll_amount', :float, :default => 0.0..1.0
	setting 'pitch_amount', :float, :default => 0.0..1.0
	setting 'yaw_amount', :float, :default => 0.0..1.0

	setting 'x_size', :float, :default => 1.0..100.0
	setting 'y_size', :float, :default => 1.0..100.0

	def render
		translate(x_offset, y_offset, z_offset) {
			roll(roll_amount) {
				pitch(pitch_amount) {
					yaw(yaw_amount) {
						scale(x_size, y_size) {
							actor.one { |a| a.do_render }
						}
					}
				}
			}
		}
		yield
	end
end
