 ###############################################################################
 #  Copyright 2006 Ian McIntosh <ian@openanswers.org>
 #
 #  This program is free software; you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
 #  the Free Software Foundation; either version 2 of the License, or
 #  (at your option) any later version.
 #
 #  This program is distributed in the hope that it will be useful,
 #  but WITHOUT ANY WARRANTY; without even the implied warranty of
 #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #  GNU Library General Public License for more details.
 #
 #  You should have received a copy of the GNU General Public License
 #  along with this program; if not, write to the Free Software
 #  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 ###############################################################################

class ProjectEffectCameraControlAnaglyph < ProjectEffect
	title				'Camera Control Anaglyph'
	description ''

	setting 'x', :float, :default => 0.0..1.0
	setting 'y', :float, :default => 0.0..1.0
	setting 'z', :float, :default => 0.0..1.0
	setting 'pitch', :float, :default => 0.0..1.0
	setting 'yaw', :float, :default => 0.0..1.0

	setting 'split', :float, :default => 0.0..1.0

	def render
		with_pixel_combine_function(:brighten) {
			with_color([1.0, 0.0, 0.0, 0.6]) {
				GL.MatrixMode(GL::PROJECTION)

				GL.PushMatrix
				GLU.LookAt(
					x + (split / 2), y, -z,
					x + (fuzzy_sine(-yaw + 0.5) - 0.5), y + (fuzzy_sine(-pitch + 0.5) - 0.5), -1, 		# TODO: look at appropriate point
					0, 1, 0) 		# up vector positive Y up vector
		 
				GL.MatrixMode(GL::MODELVIEW)
				yield
				GL.MatrixMode(GL::PROJECTION)
				GL.PopMatrix
			}

			with_color([0.0, 0.0, 1.0, 0.6]) {
				GL.PushMatrix
				GLU.LookAt(
					x - (split / 2), y, -z,
					x + (fuzzy_sine(-yaw + 0.5) - 0.5), y + (fuzzy_sine(-pitch + 0.5) - 0.5), -1, 		# TODO: look at appropriate point
					0, 1, 0) 		# up vector positive Y up vector
		 
				GL.MatrixMode(GL::MODELVIEW)
				yield
				GL.MatrixMode(GL::PROJECTION)
				GL.PopMatrix

				GL.MatrixMode(GL::MODELVIEW)
			}
		}
	end
end
