 ###############################################################################
 #  Copyright 2006 Ian McIntosh <ian@openanswers.org>
 #
 #  This program is free software; you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
 #  the Free Software Foundation; either version 2 of the License, or
 #  (at your option) any later version.
 #
 #  This program is distributed in the hope that it will be useful,
 #  but WITHOUT ANY WARRANTY; without even the implied warranty of
 #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #  GNU Library General Public License for more details.
 #
 #  You should have received a copy of the GNU General Public License
 #  along with this program; if not, write to the Free Software
 #  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 ###############################################################################

class ProjectEffectDirectorBounce < ProjectEffect
	virtual	# deprecated

	title				'Director Bounce'
	description ''

	setting 'director', :directors
	setting 'slider', :float, :range => 0.0..1.0, :default => 0.0..1.0

	def render
		@direction ||= :going		# TODO: better way to init this

	#puts "#{slider_setting.last_value} => #{slider}" <-- broken

		if (slider == 0.0 and slider_setting.last_value != 0.0)
			@direction = :going
		elsif (slider == 1.0 and slider_setting.last_value != 1.0)
			@direction = :coming
		end
	#puts @direction

		if @direction == :going
			with_env(:enter, slider) {
				with_env(:exit, 0.0) {
					director.render		# TODO: should this be yield director ??
				}
			}
		else
			with_env(:enter, 1.0) {
				with_env(:exit, 1.0 - slider) {
					director.render		# TODO: should this be yield director ??
				}
			}
		end
		yield
	end
end
