 ###############################################################################
 #  Copyright 2006 Ian McIntosh <ian@openanswers.org>
 #
 #  This program is free software; you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
 #  the Free Software Foundation; either version 2 of the License, or
 #  (at your option) any later version.
 #
 #  This program is distributed in the hope that it will be useful,
 #  but WITHOUT ANY WARRANTY; without even the implied warranty of
 #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #  GNU Library General Public License for more details.
 #
 #  You should have received a copy of the GNU General Public License
 #  along with this program; if not, write to the Free Software
 #  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 ###############################################################################

class ProjectEffectDirectorManualConsecutive < ProjectEffect
	virtual	# deprecated

	title				'Director Manual Consecutive'
	description 'Draws a director with a single enter/exit control, where enter begins goes 0.0-0.5 and exit goes 0.5->1.0'

	setting 'director', :director
	setting 'activation', :float, :range => 0.0..1.0, :default => 0.0..1.0

	def render
		# TODO: make the 0.5 a setting ;)
		with_env(:enter, (activation >= 0.5) ? 1.0 : activation / 0.5) {
			with_env(:exit, (activation > 0.5) ? (activation - 0.5) / 0.5 : 0.0) {
				director.one { |d| d.do_render }
			}
		}
		yield
	end
end
