 ###############################################################################
 #  Copyright 2006 Ian McIntosh <ian@openanswers.org>
 #
 #  This program is free software; you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
 #  the Free Software Foundation; either version 2 of the License, or
 #  (at your option) any later version.
 #
 #  This program is distributed in the hope that it will be useful,
 #  but WITHOUT ANY WARRANTY; without even the implied warranty of
 #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #  GNU Library General Public License for more details.
 #
 #  You should have received a copy of the GNU General Public License
 #  along with this program; if not, write to the Free Software
 #  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 ###############################################################################

class ProjectEffectDirectorManual < ProjectEffect
	virtual	# deprecated: control put into basic Director plugin

	title				'Director Manual'
	description 'Draws a director with direct enter and exit control'

	setting 'director', :director
	setting 'enter', :float, :range => 0.0..1.0, :default => 0.0..1.0
	setting 'exit', :float, :range => 0.0..1.0, :default => 0.0..1.0

	def render
		with_env(:enter, enter) {
			with_env(:exit, exit) {
				director.one { |d| d.do_render }
			}
		}
		yield
	end
end
