 ###############################################################################
 #  Copyright 2006 Ian McIntosh <ian@openanswers.org>
 #
 #  This program is free software; you can redistribute it and/or modify
 #  it under the terms of the GNU General Public License as published by
 #  the Free Software Foundation; either version 2 of the License, or
 #  (at your option) any later version.
 #
 #  This program is distributed in the hope that it will be useful,
 #  but WITHOUT ANY WARRANTY; without even the implied warranty of
 #  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 #  GNU Library General Public License for more details.
 #
 #  You should have received a copy of the GNU General Public License
 #  along with this program; if not, write to the Free Software
 #  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 ###############################################################################

class VariableInputSliderRate < VariableInput
	title				"Slider Rate"
	description "Slider values over 50% grows the activation, values under 50% shrinks activation"

	setting :slider, :slider
	setting :fill_time, :timespan

	def value
		if slider > 0.5
			return (last_value + (($env[:frame_time_delta] / fill_time.to_seconds) * ((slider - 0.5) / 0.5)))
		else
			return (last_value - (($env[:frame_time_delta] / fill_time.to_seconds) * ((0.5 - slider) / 0.5)))
		end
	end
end
