require 'yaml'
require 'pp'

class Settings
	def initialize
		@settings = {}
	end

	def load(path)
		File.open(path, 'r') { |file|
			load_settings_from_file(file)
			#puts "Loaded settings from #{path}..."
			#@settings.each_pair { |key, value| puts "- #{key}: #{value}" }
		} rescue nil
		self
	end

	def [](key)
		@settings[key]
	end

	def []=(key, value)
		@settings[key] = value
	end

private

	def load_settings_from_file(file)
		settings = YAML.load(file)
		@settings = settings if settings.is_a? Hash
	end
end
