require 'gl_widget'
require 'callbacks'

class GLProgressBar < GLWidget
	include Callbacks

	callback :seek

	def draw(percentage, range)
		with_unit_scale {
			with_color([0.5,0.2,0.2,1.0]) {
				unit_square
			}

			with_color_and_alpha([1.0,1.0,1.0,0.5]) {
				GL.Begin(GL::LINES)
					GL.Vertex(-0.5 + percentage, -0.5)
					GL.Vertex(-0.5 + percentage,  0.5)
				GL.End
			}
		}
	end

	def button_down(time, number, x, y)
		return unless within?(x,y)
		@grab = true
	end

	def cursor_move(time, x, y)
		if @grab
			x, y = global_to_local(x, y)
			seek_notify(x)
		end
	end

	def button_up(time, number, x, y)
		@grab = false
	end
end
