# A basic widget implementation, resizing, dragging
require 'drawing'

class GLWidget
	include Drawing

	def initialize(x,y,w,h)
		@x,@y,@width,@height = x,y,w,h
	end

	def with_unit_scale
		translate(@x, @y) {
			scale(@width/1.0, @height/1.0) {
				yield
			}
		}
	end

	def within?(x,y)
		(x >= (@x-(@width/2.0)) and x <= (@x+(@width/2.0))) and (y >= (@y-(@height/2.0)) and y <= (@y+(@height/2.0)))
	end

	def global_to_local(x, y)
		top = @y + (@height/2.0)
		bottom = @y - (@height/2.0)
		y = y.clamp(bottom, top)
		y = (y-bottom) / @height

		left = @x - (@width/2.0)
		right = @x + (@width/2.0)
		x = x.clamp(left, right)
		x = (x-left) / @width

		return x, y
	end

	#
	# Override these
	#
	def update(time)
	end

	def draw
	end

	def cursor_move(time, x, y)
	end

	def button_down(time, number, x, y)
	end

	def button_up(time, number, x, y)
	end
end
